Index: /trunk/gsdl3/resources/java/GS2Construct.properties
===================================================================
--- /trunk/gsdl3/resources/java/GS2Construct.properties	(revision 3660)
+++ /trunk/gsdl3/resources/java/GS2Construct.properties	(revision 3660)
@@ -0,0 +1,55 @@
+#the params used by the services
+param.collection=Collection
+param.creator=Creator's email address
+param.collectionName=Name of the collection
+
+#service names and submit buttons
+DeleteCollection.name=Delete a collection
+DeleteCollection.submit=Delete
+NewCollection.name=Create a collection
+NewCollection.submit=Create
+ImportCollection.name=Import a collection
+ImportCollection.submit=Import
+BuildCollection.name=Build a collection
+BuildCollection.submit=Build
+ActivateCollection.name=Activate a collection
+ActivateCollection.submit=Activate
+ReloadCollection.name=Reload a collection
+ReloadCollection.submit=Reload
+
+#error messages used by each service - {0} is the collection name
+#DeleteCollection######
+delete.deactivate_error=Couldn't deactivate {0} from the library.
+delete.delete_error=Couldn't delete {0}.
+delete.success=Collection {0} deleted successfully.
+
+#NewCollection######
+new.success=Collection {0} created successfully.
+
+#ImportCollection#####
+import.success=Collection {0} imported successfully.
+
+#BuildCollection#####
+build.success=Collection {0} built successfully.
+
+#ActivateCollection#####
+activate.build_dir_error=Collection {0} had no building directory: couldn't be activated.
+activate.build_config_error=Collection {0} had no building config file: couldn't be activated.
+activate.rm_index_error=Couldn't remove the index directory.
+activate.rename_building_error=Couldn't rename building to index.
+activate.success=Collection {0} activated successfully.
+
+#ReloadCollection#####
+reload.success=Collection {0} reloaded successfully.
+reload.activate_error=Couldn't activate collection {0} in the library.
+
+
+
+
+
+
+
+
+
+
+
Index: /trunk/gsdl3/resources/java/GS2Construct_fr.properties
===================================================================
--- /trunk/gsdl3/resources/java/GS2Construct_fr.properties	(revision 3660)
+++ /trunk/gsdl3/resources/java/GS2Construct_fr.properties	(revision 3660)
@@ -0,0 +1,51 @@
+#the params used by the services
+param.collection=Collection <fr>
+param.creator=Creator's email address <fr>
+param.collectionName=Name of the collection <fr>
+
+#service names and submit buttons
+DeleteCollection.name=Delete a collection <fr>
+DeleteCollection.submit=Delete <fr>
+
+#messages for each service
+#DeleteCollection######
+delete.deactivate_error=Couldn't deactivate {0} from the library. <fr>
+delete.delete_error=Couldn't delete {0}. <fr>
+delete.success=Collection {0} deleted successfully. <fr>
+delete.submit=Delete <fr>
+
+#NewCollection######
+new.success=Collection {0} created successfully. <fr>
+new.submit=Create <fr>
+
+#ImportCollection#####
+import.success=Collection {0} imported successfully. <fr>
+import.submit=Import <fr>
+
+#BuildCollection#####
+build.success=Collection {0} built successfully. <fr>
+build.submit=Build <fr>
+
+#ActivateCollection#####
+#activate.build_dir_error=Collection {0} had no building directory: couldn't be activated. <fr>
+activate.build_config_error=Collection {0} had no building config file: couldn't be activated. <fr>
+activate.rm_index_error=Couldn't remove the index directory. <fr>
+activate.rename_building_error=Couldn't rename building to index. <fr>
+activate.success=Collection {0} activated successfully. <fr>
+activate.submit=Activate <fr>
+
+#ReloadCollection#####
+reload.success=Collection {0} reloaded successfully. <fr>
+reload.activate_error=Couldn't activate collection {0} in the library. <fr>
+reload.submit=Reload <fr>
+
+
+
+
+
+
+
+
+
+
+
Index: /trunk/gsdl3/resources/java/GS2MGPPRetrieve.properties
===================================================================
--- /trunk/gsdl3/resources/java/GS2MGPPRetrieve.properties	(revision 3660)
+++ /trunk/gsdl3/resources/java/GS2MGPPRetrieve.properties	(revision 3660)
@@ -0,0 +1,7 @@
+#query params
+
+#service stuff
+ResourceRetrieve.name=Retrieve documents
+ResourceRetrieve.submit=Get
+MetadataRetrieve.name=Retrieve metadata
+MetadataRetrieve.submit=Get
Index: /trunk/gsdl3/resources/java/GS2MGPPSearch.properties
===================================================================
--- /trunk/gsdl3/resources/java/GS2MGPPSearch.properties	(revision 3660)
+++ /trunk/gsdl3/resources/java/GS2MGPPSearch.properties	(revision 3660)
@@ -0,0 +1,31 @@
+#query params
+param.stem=Turn stemming 
+param.case=Turn casefolding 
+param.index=Index to search in
+param.level=Granularity to search at
+param.maxDocs=Maximum documents to return
+param.sortBy=Display documents in
+param.sortBy.rank=ranked order
+param.sortBy.natural=natural order
+param.matchMode=Match
+param.matchMode.all=all of the words
+param.matchMode.some=some of the words
+param.query=Enter your query string
+param.boolean.on=on
+param.boolean.off=off
+param.fqv=Search for 
+param.fqf=in field
+param.fqs=stem
+param.fqc=case
+param.fqk=
+param.fqk.0=AND
+param.fqk.1=OR
+param.fqk.2=NOT
+
+#service stuff
+TextQuery.name=Query
+TextQuery.submit=Search
+FieldQuery.name=Form Query
+FieldQuery.submit=Search
+AdvancedFieldQuery.name=Advanced Form Query
+AdvancedFieldQuery.submit=Search
Index: /trunk/gsdl3/resources/java/GS2MGPPSearch_fr.properties
===================================================================
--- /trunk/gsdl3/resources/java/GS2MGPPSearch_fr.properties	(revision 3660)
+++ /trunk/gsdl3/resources/java/GS2MGPPSearch_fr.properties	(revision 3660)
@@ -0,0 +1,21 @@
+#query params
+param.stem=Turn stemming 
+param.case=Turn casefolding 
+param.index=Index to search in
+param.level=Granularity to search at
+param.maxDocs=Maximum documents to return
+param.sortBy=Display documents in
+param.sortBy.rank=ranked order
+param.sortBy.natural=natural order
+param.matchMode=Match
+param.matchMode.all=all of the words
+param.matchMode.some=some of the words
+
+param.boolean.on=on
+param.boolean.off=off
+
+#service stuff
+TextQuery.name=Query
+TextQuery.submit=Recherche
+FieldQuery.name=Advanced Query
+FieldQuery.submit=Recherche
Index: unk/gsdl3/resources/java/MGPPGDBMServices.properties
===================================================================
--- /trunk/gsdl3/resources/java/MGPPGDBMServices.properties	(revision 3659)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#query params
-param.stem=Turn stemming 
-param.case=Turn casefolding 
-param.index=Index to search in
-param.level=Granularity to search at
-param.maxDocs=Maximum documents to return
-param.sortBy=Display documents in
-param.sortBy.rank=ranked order
-param.sortBy.natural=natural order
-param.matchMode=Match
-param.matchMode.all=all of the words
-param.matchMode.some=some of the words
-param.query=Enter your query string
-param.boolean.on=on
-param.boolean.off=off
-param.fqv=Search for 
-param.fqf=in field
-param.fqs=stem
-param.fqc=case
-param.fqk=
-param.fqk.0=AND
-param.fqk.1=OR
-param.fqk.2=NOT
-
-#service stuff
-TextQuery.name=Query
-TextQuery.submit=Search
-FieldQuery.name=Form Query
-FieldQuery.submit=Search
-AdvancedFieldQuery.name=Advanced Form Query
-AdvancedFieldQuery.submit=Search
-ResourceRetrieve.name=Retrieve documents
-ResourceRetrieve.submit=Get
-MetadataRetrieve.name=Retrieve metadata
-MetadataRetrieve.submit=Get
Index: unk/gsdl3/resources/java/MGPPGDBMServices_fr.properties
===================================================================
--- /trunk/gsdl3/resources/java/MGPPGDBMServices_fr.properties	(revision 3659)
+++ 	(revision )
@@ -1,25 +1,0 @@
-#query params
-param.stem=Turn stemming 
-param.case=Turn casefolding 
-param.index=Index to search in
-param.level=Granularity to search at
-param.maxDocs=Maximum documents to return
-param.sortBy=Display documents in
-param.sortBy.rank=ranked order
-param.sortBy.natural=natural order
-param.matchMode=Match
-param.matchMode.all=all of the words
-param.matchMode.some=some of the words
-
-param.boolean.on=on
-param.boolean.off=off
-
-#service stuff
-TextQuery.name=Query
-TextQuery.submit=Recherche
-FieldQuery.name=Advanced Query
-FieldQuery.submit=Recherche
-ResourceRetrieve.name=Retrieve documents
-ResourceRetrieve.submit=Get
-MetadataRetrieve.name=Retrieve metadata
-MetadataRetrieve.submit=Get
Index: unk/gsdl3/resources/java/PerlBuildServices.properties
===================================================================
--- /trunk/gsdl3/resources/java/PerlBuildServices.properties	(revision 3659)
+++ 	(revision )
@@ -1,55 +1,0 @@
-#the params used by the services
-param.collection=Collection
-param.creator=Creator's email address
-param.collectionName=Name of the collection
-
-#service names and submit buttons
-DeleteCollection.name=Delete a collection
-DeleteCollection.submit=Delete
-NewCollection.name=Create a collection
-NewCollection.submit=Create
-ImportCollection.name=Import a collection
-ImportCollection.submit=Import
-BuildCollection.name=Build a collection
-BuildCollection.submit=Build
-ActivateCollection.name=Activate a collection
-ActivateCollection.submit=Activate
-ReloadCollection.name=Reload a collection
-ReloadCollection.submit=Reload
-
-#error messages used by each service
-#DeleteCollection######
-delete.deactivate_error=Couldn't deactivate {0} from the library.
-delete.delete_error=Couldn't delete {0}.
-delete.success=Collection {0} deleted successfully.
-
-#NewCollection######
-new.success=Collection {0} created successfully.
-
-#ImportCollection#####
-import.success=Collection {0} imported successfully.
-
-#BuildCollection#####
-build.success=Collection {0} built successfully.
-
-#ActivateCollection#####
-activate.build_dir_error=Collection {0} had no building directory: couldn't be activated.
-activate.build_config_error=Collection {0} had no building config file: couldn't be activated.
-activate.rm_index_error=Couldn't remove the index directory.
-activate.rename_building_error=Couldn't rename building to index.
-activate.success=Collection {0} activated successfully.
-
-#ReloadCollection#####
-reload.success=Collection {0} reloaded successfully.
-reload.activate_error=Couldn't activate collection {0} in the library.
-
-
-
-
-
-
-
-
-
-
-
Index: unk/gsdl3/resources/java/PerlBuildServices_fr.properties
===================================================================
--- /trunk/gsdl3/resources/java/PerlBuildServices_fr.properties	(revision 3659)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#the params used by the services
-param.collection=Collection <fr>
-param.creator=Creator's email address <fr>
-param.collectionName=Name of the collection <fr>
-
-#service names and submit buttons
-DeleteCollection.name=Delete a collection <fr>
-DeleteCollection.submit=Delete <fr>
-
-#messages for each service
-#DeleteCollection######
-delete.deactivate_error=Couldn't deactivate {0} from the library. <fr>
-delete.delete_error=Couldn't delete {0}. <fr>
-delete.success=Collection {0} deleted successfully. <fr>
-delete.submit=Delete <fr>
-
-#NewCollection######
-new.success=Collection {0} created successfully. <fr>
-new.submit=Create <fr>
-
-#ImportCollection#####
-import.success=Collection {0} imported successfully. <fr>
-import.submit=Import <fr>
-
-#BuildCollection#####
-build.success=Collection {0} built successfully. <fr>
-build.submit=Build <fr>
-
-#ActivateCollection#####
-#activate.build_dir_error=Collection {0} had no building directory: couldn't be activated. <fr>
-activate.build_config_error=Collection {0} had no building config file: couldn't be activated. <fr>
-activate.rm_index_error=Couldn't remove the index directory. <fr>
-activate.rename_building_error=Couldn't rename building to index. <fr>
-activate.success=Collection {0} activated successfully. <fr>
-activate.submit=Activate <fr>
-
-#ReloadCollection#####
-reload.success=Collection {0} reloaded successfully. <fr>
-reload.activate_error=Couldn't activate collection {0} in the library. <fr>
-reload.submit=Reload <fr>
-
-
-
-
-
-
-
-
-
-
-