Index: /trunk/gsdl/src/recpt/browsetools.cpp
===================================================================
--- /trunk/gsdl/src/recpt/browsetools.cpp	(revision 3665)
+++ /trunk/gsdl/src/recpt/browsetools.cpp	(revision 3666)
@@ -74,5 +74,5 @@
     int count = 0;
     while (here != end) {
-      if ((count != 0) && ((count % 2) == 0)) textout << "<br>\n";
+      if ((count != 0) && ((count % 2) == 0)) textout<< outconvert << "<br>\n";
       textout << outconvert << disp << *here;
       count ++;
@@ -607,5 +607,5 @@
 		formatinfo, collectproto, disp, outconvert, textout, logout);
 
-	textout << "</table></td></tr></table>\n";
+	textout << outconvert << "</table></td></tr></table>\n";
 }
 
@@ -764,9 +764,9 @@
   // if we're inside a book
   if ((!fulltoc) && (!args["d"].empty())) {
-    textout << "<center>\n";
+    textout << outconvert << "<center>\n";
     textout << outconvert << disp << "<p><table width=_pagewidth_ cellpadding=0 cellspacing=0><tr>\n";
-    textout << "<td valign=top align=left";
-    if (formatinfo.DocumentContents) textout << " width=200>\n";
-    else textout << " width=100%>\n";
+    textout << outconvert << "<td valign=top align=left";
+    if (formatinfo.DocumentContents) textout << outconvert << " width=200>\n";
+    else textout << outconvert << " width=\"100%\">\n";
     if (formatinfo.DocumentImages) 
       output_cover_image (args, collectproto, disp, outconvert, textout, logout);
@@ -777,5 +777,5 @@
 		       outconvert, textout, logout);
     }
-    textout << "</td><td valign=top>\n";  
+    textout << outconvert << "</td><td valign=\"top\">\n";  
     havecontrols = true;
   }
@@ -800,5 +800,5 @@
   }
 
-  if (havecontrols) textout << "</td></tr></table></center>\n"; 
+  if (havecontrols) textout << outconvert << "</td></tr></table></center>\n"; 
 
   //if there is a format specified in the config file then
Index: /trunk/gsdl/src/recpt/datelistbrowserclass.cpp
===================================================================
--- /trunk/gsdl/src/recpt/datelistbrowserclass.cpp	(revision 3665)
+++ /trunk/gsdl/src/recpt/datelistbrowserclass.cpp	(revision 3666)
@@ -68,5 +68,5 @@
 
   if (use_table || colnumber > 0) {
-    textout << "<table><tr><td>";
+    textout << outconvert << "<table><tr><td>";
     // get tab size
     text_t tab; int itab;
@@ -74,9 +74,9 @@
     itab = tab.getint();
     if (colnumber > 0) 
-      textout << "<img src=\"_httpimg_/space.gif\" width=" << (itab*colnumber) << ">";
-    textout<< "</td><td>";
+      textout << outconvert << "<img src=\"_httpimg_/space.gif\" width=" << (itab*colnumber) << ">";
+    textout << outconvert << "</td><td>";
   }
 
-  textout << "<table>\n";
+  textout << outconvert << "<table>\n";
 
   ResultDocInfo_tarray::iterator thissection = sections.docInfo.begin();
@@ -108,5 +108,5 @@
     } else link += args["cl"] + "&d=" + (*thissection).OID + "\">";
 
-    textout << "<tr valign=top>";
+    textout << outconvert << "<tr valign=top>";
 
     if (thisyear != lastyear) {
@@ -114,5 +114,5 @@
       lastyear = thisyear;
     } else
-      textout << "<td></td>";
+      textout << outconvert << "<td></td>";
     
     if (thismonth != lastmonth) {
@@ -120,7 +120,7 @@
       lastmonth = thismonth;
     } else
-      textout << "<td></td>";
+      textout << outconvert << "<td></td>";
     
-    if (!use_table) textout << "<td>\n";
+    if (!use_table) textout << outconvert << "<td>\n";
     
     textout << outconvert << disp 
@@ -130,14 +130,14 @@
 				     logout) << "\n";
     
-    if (!use_table) textout << "</td>";
+    if (!use_table) textout << outconvert << "</td>";
     
-    textout << "</tr>\n";
+    textout << outconvert << "</tr>\n";
     
     thissection ++;
   }
 
-  textout << "</table>\n";
+  textout << outconvert << "</table>\n";
 
-  if (use_table  || colnumber > 0) textout << "</td></tr></table>\n";
+  if (use_table  || colnumber > 0) textout << outconvert << "</td></tr></table>\n";
   return 1;
 }
Index: /trunk/gsdl/src/recpt/documentaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/documentaction.cpp	(revision 3665)
+++ /trunk/gsdl/src/recpt/documentaction.cpp	(revision 3666)
@@ -772,5 +772,5 @@
     // output the document text
     if (!args["d"].empty()) {
-      textout << "<p>\n";
+      textout << outconvert << "<p>\n";
       output_document (OID, args, collectproto, disp, outconvert, textout, logout);
     }
Index: /trunk/gsdl/src/recpt/hlistbrowserclass.cpp
===================================================================
--- /trunk/gsdl/src/recpt/hlistbrowserclass.cpp	(revision 3665)
+++ /trunk/gsdl/src/recpt/hlistbrowserclass.cpp	(revision 3666)
@@ -101,5 +101,5 @@
 					
   if (use_table || colnumber > 0) {
-    textout << "<table><tr><td>";
+    textout << outconvert << "<table><tr><td>";
     // get tab size
     text_t tab; int itab;
@@ -109,8 +109,8 @@
 			       << "<img src=\"_httpimg_/space.gif\" width=" 
 			       << (itab*colnumber) << ">";
-    textout << "</td>\n";
+    textout << outconvert << "</td>\n";
   }
 
-  textout << "<table><tr>\n";
+  textout << outconvert << "<table><tr>\n";
 
   ResultDocInfo_tarray::iterator tsibling = response.docInfo.begin();
@@ -158,14 +158,14 @@
 
     if (num_chars>100) { // this is fairly arbitrary...
-      textout << "</tr>\n<tr>";
+      textout << outconvert << "</tr>\n<tr>";
       num_chars=0;
     }
 
-    textout << "<td>" << outconvert << disp << fmt_str << "</td>\n";
+    textout << outconvert << "<td>" << disp << fmt_str << "</td>\n";
     tsibling ++;
   }
 
-  textout << "</tr></table>\n";
-  if (use_table  || colnumber > 0) textout << "</tr></table>\n";
+  textout << outconvert << "</tr></table>\n";
+  if (use_table  || colnumber > 0) textout << outconvert << "</tr></table>\n";
   return 0;
 }
Index: /trunk/gsdl/src/recpt/vlistbrowserclass.cpp
===================================================================
--- /trunk/gsdl/src/recpt/vlistbrowserclass.cpp	(revision 3665)
+++ /trunk/gsdl/src/recpt/vlistbrowserclass.cpp	(revision 3666)
@@ -73,5 +73,5 @@
 
   if (use_table || colnumber > 0) {
-    textout << "<table><tr valign=top>";
+    textout << outconvert << "<table><tr valign=top>";
     // get tab size
     text_t tab; int itab;
@@ -88,5 +88,5 @@
 				   link, icon, highlight, logout);
   
-  if (use_table  || colnumber > 0) textout << "</tr></table>\n";
+  if (use_table  || colnumber > 0) textout << outconvert << "</tr></table>\n";
 
   return 1;
@@ -109,5 +109,5 @@
 
   if (colnumber > 0) {
-    textout << "<table><tr valign=top>";
+    textout << outconvert << "<table><tr valign=top>";
     // get tab size
     text_t tab; int itab;
@@ -117,7 +117,7 @@
 			       << "<td><img src=\"_httpimg_/space.gif\" width=" 
 			       << (itab*colnumber) << "></td>";
-    textout << "<td>";
-  }
-  if (use_table) textout << "<table>\n";
+    textout << outconvert << "<td>";
+  }
+  if (use_table) textout << outconvert << "<table>\n";
 
   ResultDocInfo_tarray::iterator thissection = sections.docInfo.begin();
@@ -150,5 +150,5 @@
 
     if ((item == 1 && use_table) || colnumber > 0 )
-      textout << "<tr valign=top>\n";
+      textout << outconvert << "<tr valign=top>\n";
 
     textout << outconvert << disp 
@@ -157,13 +157,13 @@
 
     if ((item >= perline && use_table) || colnumber > 0) {
-      textout << "\n</tr>";
+      textout << outconvert << "\n</tr>";
       item = 0;
     }
-    textout << "\n";
+    textout << outconvert << "\n";
     thissection ++;
   }
 
-  if (use_table) textout << "</table>\n";
-  if (colnumber > 0) textout << "</table></td></tr></table>\n";
+  if (use_table) textout << outconvert << "</table>\n";
+  if (colnumber > 0) textout << outconvert << "</table></td></tr></table>\n";
 
   return 1;