Index: /trunk/niupepa/macros/abexpl.dm
===================================================================
--- /trunk/niupepa/macros/abexpl.dm	(revision 3701)
+++ /trunk/niupepa/macros/abexpl.dm	(revision 3702)
@@ -9,41 +9,93 @@
 </center>
 <h2>English Abstracts of the MÄori Language Newspapers</h2>
-<h3>Introduction</h3>
-<P>The English abstracts of the MÄori language newspapers are designed to give an impression of a whole newspaper 
-issue and to guide researchers to particular topics or information for translation. Although every item in an issue 
-is noted, the abstracts do not represent a full translation of the entire contents. They summarise long items such 
-as editorials, articles, and letters, and briefly record, sometimes by a complete translation, small items such as 
-notices, advertisements, short news reports. In sum the abstracts represent an abbreviated form of a newspaper and 
-so to ensure a complete reading of any item researchers will need to refer to or seek translation of the MÄori text.
 
-<P>The abstracts follow the order of  items in a newspaper and include the titles and subtitles. Apart from occasional 
-additions in square brackets to clarify or inform, the abstracts report only what is in the newspaper. Where English 
-translation is published in the paper this is noted together with a brief statement of content.
-<P>A few MÄori words remain in the abstracts without translation because they are key words for researchers of MÄori 
-language and culture. These are highlighted and can be clicked on for explanation in the glossary. MÄori names (personal, 
-place and tribal) have been written according to contemporary spelling as far as this is known.
-<P>The English abstracts are being created by a team of researchers who, in 1999, began a three-year project into the 
-history and contents of  these newspapers. The project is funded by grants from the Marsden Fund and the Trustees of 
-the National Library. The research team, from the Department of MÄori Studies at the University of Auckland, comprises 
-Professor Ngapare Hopa, Dr Jane McRae, Jenifer Curnow, and postgraduate researchers Dinah Paul, Hazel Petrie, Yvonne 
-Sutherland, and Lyn Waymouth. They work collaboratively with the History of Print Culture in New Zealand Research Project, 
-and with Professor Mark Apperley and Te Taka Keegan of the Computer Science Department, University of Waikato, who are 
-carrying out the on-line conversion of the abstracts.
+<p><i>The English abstracts are being created by a research team at
+the Department of Maori Studies of the University of Auckland. This
+translation work began in 1999 and was funded for a three-year period
+by grants from the Royal Society of New Zealand's Marsden Fund and the
+Trustees of the National Library of New Zealand. The research team
+over that period comprised Professor Ngapare Hopa, Dr Jane McRae,
+Jenifer Curnow, and the postgraduate researchers who wrote the English
+abstracts - Tane Mokena, Dinah Paul, Hazel Petrie, Yvonne Sutherland,
+Lyn Waymouth. The team worked in association with the History of Print
+Culture in New Zealand, the Alexander Turnbull Library, and the
+Computer Science Department of the University of Waikato where
+Professors Mark Apperley and Ian Witten, Te Taka Keegan and others are
+carrying out the on-line conversion of the newspapers and English
+abstracts. Specific help with production of the abstracts is
+acknowledged from Hineira Woodard for translation queries, Stephen
+Innes of the University of Auckland Library's New Zealand &amp;
+Pacific Collection for access to research material, and Roberta Wilson
+for assistance with computers. As further funding is obtained, more
+English abstracts will be included on the website.</i></p>
+      
+<h3>Introduction &amp; Conventions</h3>
 
-<h3>Glossary</h3>
-<P>MÄori words
-<P>The following MÄori words have been retained in the abstracts because they are key words for researchers into 
-MÄori language and culture. They are used here generically and so refer to all the different kinds of texts within 
-these genres.
-<P>karakia: incantations
-<P>kÅrero: narratives 
-<P>waiata: sung and recited poetry
-<P>whakapapa: genealogy
-<P>whakataukÄ«: sayings, set expressions
+<p>We have created the English abstracts to facilitate use of the
+Maori-language newspapers by those who do not read Maori. They are
+designed to guide readers and researchers to particular articles or
+information and to give an impression of a whole newspaper
+issue. Every item in an issue is noted but the abstracts are not an
+account of the entire content. They briefly summarise the main
+subjects of long items, such as editorials, articles, and letters, and
+record, sometimes by a complete translation, small items such as
+notices, advertisements, short news reports. In sum the abstracts
+represent a very abbreviated form of a newspaper, and so to ensure a
+complete reading of any item you will need to refer to, or seek
+translation of, the Maori text. We suggest, therefore, that you do not
+quote from the abstracts.</p>
 
-<h3>Abbreviations</h3>
-CMS: Church Missionary Society
-<P>MLC: Member of the Legislative Council
-<P>MHR: Member of the House of Representatives
-<P>WMMS: Wesleyan Missionary Society
+<p>The abstracts follow the order of items in the newspapers and
+include the titles and subtitles from them. Apart from occasional
+interpolations in square brackets to clarify, inform or query, the
+abstracts report only what is in the newspaper. Where English
+translation is published in the paper, this is noted after a brief
+statement of content. Abbreviations used are listed below.</p>
+
+<p>A few Maori words remain in the abstracts, with translation in
+brackets. These remain either because we regard them as key words for
+researchers of Maori language and culture (words such as waiata,
+whakapapa, whakataukÄ«), or because there is no equivalent in
+English for the word or the word has different meanings in different
+contexts (words such as mana, mÄkutu, tohunga, pÄ). We
+have used the Maori word 'Pakeha' in the abstracts to refer to those
+in New Zealand who are not Maori, because this use is common in the
+newspapers and in current New Zealand speech.</p>
+
+<p>Maori names - personal, place and tribal - have been written
+according to modern spelling. Long vowels have been marked in all
+names, as far as these are known, on the basis of authorities such as
+the Dictionary of New Zealand Biography, of unambiguous component
+words in a name, or of common usage.  In the case of Pakeha whose
+names have been transliterated to Maori, the translators have given
+the original name only when it is evident who the person is; otherwise
+the transliterated form remains.</p>
+
+<p>We hope that you will find the abstracts of value to your research
+and enjoyable for the window they open onto 19th and early 20th
+century Maori life and New Zealand society. We have made every effort
+to make accurate abstracts of the contents, but we remind you that
+these are simply summaries. We have not given them the time or
+research required for full and explicit translations. Given so many
+newspapers, the very diverse content, and the historical context, we
+may have overlooked some things and misjudged others.  If in your
+reading you notice errors or omissions, we would be very grateful if
+you would notify us by email (to j.mcrae@auckland.ac.nz) so that we
+may correct them.</p>
+
+
+<p>The following abbreviations have been used in the abstracts:</p>
+<table border="0">
+<tr valign="top"><td>CMS</td><td>Church Missionary Society</td></tr>
+<tr valign="top"><td>WMMS</td><td>Wesleyan Methodist Missionary Society</td></tr>
+<tr valign="top"><td>MHR</td><td>Member of the House of Representatives</td></tr>
+<tr valign="top"><td>MP</td><td>Member of Parliament</td></tr>
+<tr valign="top"><td>MLC</td><td>Member of the Legislative Council</td></tr>
+</table>
+
+<table border="0" width="_pagewidth_">
+<tr><td align="right">
+<small>Updated in August, 2002</small>
+</td></tr>
+</table>
 }