Index: /trunk/gsdl3/INSTALL
===================================================================
--- /trunk/gsdl3/INSTALL	(revision 3705)
+++ /trunk/gsdl3/INSTALL	(revision 3706)
@@ -97,3 +97,7 @@
 address for talking to the tomcat SOAP servlet services.
 
+Note: you can change tomcat to use a different port if you like. Edit comms/tomcat/jakarta/conf/server.xml, and change 8080 to whatever. If you do this, and are using soap, you need to remember to change the port number in:
 
+the install-soap.bash file where it tries to deploy site1.
+the siteConfig.xml file for any site that wants to talk to a soap service running on this tomcat.
+
Index: /trunk/gsdl3/RUNNING
===================================================================
--- /trunk/gsdl3/RUNNING	(revision 3705)
+++ /trunk/gsdl3/RUNNING	(revision 3706)
@@ -24,5 +24,5 @@
 
 The interface and site to use for a particular servlet is determined by the 
-init-params in the web.xml file 
+init-params in the web.xml file (web/WEB-INF/web.xml)
 
 XSL Files: when an xslt file is to be used, eg home.xsl, it is looked for in 
@@ -40,5 +40,4 @@
 
 only mgpp collections can be searched - use mgppdemo, not demo.
-Currently, only Text search works.
 
 to change the interface language, you can add &l=fr to the url. However, there are no alternative langs at the moment.
@@ -60,30 +59,9 @@
 directly to the message router
 
-basically messages are like:
-
-<message><request type="describe|query" to="demo/TextQuery" info=""/></message>
-with type="describe", to="", can use serviceList, collectionList and siteList 
-for the info field.
+see the manual for sample messages.
 
 this program is not very useful - except for debugging - when using the servlet
-or Library2, can print out the messages - then cut and paste these for teh 
+or Library2, can print out the messages - then cut and paste these for  
 input to Library1
-
-sample messages: (to cut and paste)
-
-describe request to message router:
-<message><request type="describe" to=""/></message>
-
-describe request to collection:
-<message><request type="describe" to="mgppdemo"/></message>
-
-query:
-<message><request type="query" to="mgppdemo/TextQuery"><paramList/><content>the</content></request></message>
-
-get Titles for a list of docs:
-<message><request type="query" to="mgppdemo/MetadataRetrieve"><paramList/><content><resourceList><resource name="HASH30aa188f4d8ddaef558fc9" /><resource name="HASH0102361bccb095d60673448c.3" /><resource name="HASH4632a8a51d33c47a75c559.4.1.5" /></resourceList><metadataList><element name="Title"/></metadataList></content></request></message>
-
-get a document:
-<message><request type="query" to="mgppdemo/ResourceRetrieve"><paramList/><content><resourceList><resource name="HASH30aa188f4d8ddaef558fc9" /></resourceList></content></request></message>
 
 
@@ -93,29 +71,4 @@
 
 takes xml request of 'cgi' params, and returns html (input must be all on one line)
-
-<message lang="en">
-<request type="action" action="q" subaction="text">
-<paramList>
-<param name="q" value="the"/>
-</paramList>
-</request>
-</message>
-
-the info field is action/subaction, eg a=p&sa=home, or a=q&sa=text
-
-Some sample queries: (to cut and paste)
-
-home page:
-<message lang="en"><request type="action" action="p" subaction="home" /></message>
-
-about page for mgppdemo:
-<message lang="en"><request type="action" action="p" subaction="about""><paramList><param name="c" value="mgppdemo"/></paramList></request></message>
-
-search for frog in mgppdemo: (no docs returned)
-<message lang="en"><request type="action" action="q" subaction="text"><paramList><param name="c" value="mgppdemo"/><param name="q" value="frog"/><param name="md" value="10"/></paramList></request></message>
-
-search for frog in mgppdemo, with stemming on: (some docs returned)
-<message lang="en"><request type="action" action="q" subaction="text""><paramList><param name="c" value="mgppdemo"/><param name="q" value="frog"/><param name="md" value="10"/><param name="s" value="1"/></paramList></request></message>
-
 
 Collections: