Index: /trunk/gsdl/macros/english.dm
===================================================================
--- /trunk/gsdl/macros/english.dm	(revision 3878)
+++ /trunk/gsdl/macros/english.dm	(revision 3879)
@@ -7,5 +7,5 @@
 # This is the main macro file for translation when creating an 
 # interface in another language.
-#
+
 # Under the 'text macros' comments are text macros of the form:
 # _macroname_ {macro value}
@@ -78,4 +78,5 @@
 _textimagepref_ {Preferences page}
 _textimagegreenstone_ {Greenstone Digital Library Software}
+_textimageusab_ {I'd like to complain}
 
 _textimagesearch_ {Search for specific terms}
@@ -184,4 +185,9 @@
 _httpiconcprefof_ {_httpimg_/cprefof.gif}
 _httpiconcprefon_ {_httpimg_/cprefon.gif}
+
+## "I'D LIKE TO COMPLAIN" ## top_nav_button ## cusab ##
+_httpiconcusabof_ {_httpimg_/cusabof.gif}
+_httpiconcusabon_ {_httpimg_/cusabon.gif}
+
 
 ## "help" ## green_title ## h_help ##
@@ -1217,2 +1223,82 @@
 <p>If documents are books, they will be opened at the appropriate place.
 }
+
+package Global
+
+############################################################################
+#
+# This stuff is only used by the usability (I'd like to Complain) stuff
+#
+############################################################################
+
+_greenstoneusabilitytext_ {Greenstone Usability}
+
+_textonlyusabinterface_ {<p>You are about to tell us that you have found this web page confusing or frustrating. We promise not to take any information other than information about this web page and how you are viewing it. <p>Would you still like to send this data?}
+
+_texterror_ {error}
+_textyes_{Yes}
+_textno_{No}
+_textclosewindow_{Close Window}
+_textabout_ {About}
+_textprivacy_ {Privacy}
+_textsend_ {Send}
+_textdontsend_{Don\\'t Send}
+_textoptionally_{Optionally}
+
+_textunderdev_{This functionality is still under development, and has not yet been properly researched.  Please try again later.}
+
+_textviewdetails_{View Details}
+_textmoredetails_{More Details}
+_texttrackreport_{Track this report}
+_textcharacterise_{Characterise the problem}
+_textseverity_{How bad is the problem}
+ 
+_textbadrender_{Bad rendering}
+_textcontenterror_{Content error}
+_textstrangebehaviour_{Strange behaviour}
+_textunexpected_{Something unexpected happened}
+_textfunctionality_{Hard to find functionality}
+
+_textmajor_{Serious}
+_textmedium_{Medium}
+_textminor_{Minor}
+_texttrivial_{Trivial}
+
+_textwhatdoing_{What were you trying to do?}
+_textwhatexpected_{What did you expect to happen?}
+_textwhathappened_{What actually happened?}
+
+_cannotfindcgierror_ {<h2>Sorry!</h2>Can\\'t find the server programs for the &quot;I\\'d Like to Complain&quot; button.}
+
+_textusabbanner_ {the Greenstone koru-style banner}
+
+package Usability
+
+_textaboutusabilitypagetitle_{About the &quot;I'd like to Complain&quot; button}
+_textaboutusabilitytitle_{About the &quot;I'd like to Complain&quot; button}
+_textaboutusability_{
+Many open source projects suffer because normal users find the software they produce hard to use; studies have shown that Greenstone is one of these projects.  The &quot;I'd like to Complain&quot; button is an attempt by members of the Greenstone project to involve the users of Greenstone in making the software easier to use.
+<p>Every time you send data about the Greenstone interface, some information is collected about what you were doing in Greenstone at the time (this is available from the URL or web address of the Greenstone page where you clicked the button), a little about the browser you were using and the screen settings, and the time.  This information can hopefully help the people working on the Greenstone project to figure out what caused the problems you had, and how to fix it.
+
+<p>If you would like to know more about this, please <a href="mailto:dmn&#064;cs.waikato.ac.nz">contact us</a>
+ 
+<p>For more information about privacy please see <a href="_gwcgi_?e=_compressedoptions_&a=p&p=Privacy">our privacy policy</a>.
+}
+
+package Privacy
+
+_textaboutprivacypagetitle_ {Privacy Policy}
+_textaboutprivacytitle_ {Privacy Policy}
+_textaboutprivacy_{
+Privacy is an important concern to us.  We assure you that we will take no information that can lead to your personal identification. Any information taken will be used strictly for research purposes, and no identifying information will be published.
+<p>The information we take will have a timestamp on it, and may be correlated with your activity <i>within Greenstone</i> around the time you made your complaint.  No information about anything other than Greenstone will be taken.
+
+<p>If you would like to know more about this, please <a href="mailto:dmn&#064;cs.waikato.ac.nz">contact us</a>
+ 
+<p>For more information about this work please see <a href="_gwcgi_?e=_compressedoptions_&a=p&p=Usability">our about page</a>.
+
+}
+
+
+
+