Index: /trunk/indexers/mgpp/jni/win32.mak
===================================================================
--- /trunk/indexers/mgpp/jni/win32.mak	(revision 3930)
+++ /trunk/indexers/mgpp/jni/win32.mak	(revision 3930)
@@ -0,0 +1,70 @@
+###########################################################################
+#
+# win32 makefile -- mgpp\jni
+# A component of the Greenstone digital library software
+# from the New Zealand Digital Library Project at the
+# University of Waikato, New Zealand.
+#
+# Copyright (C) 1999  The New Zealand Digital Library Project
+#
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+###########################################################################
+ 
+MGPPHOME = ..
+
+AR = lib
+CC = cl
+CPPFLAGS = -GX
+
+DEFS = -DQUIET -DSHORT_SUFFIX -DHAVE_STRING_H -D__WIN32__
+INCLUDES = -I"$(MGPPHOME)" -I"$(MGPPHOME)\lib" -I"$(MGPPHOME)\text" \
+           -I"C:\j2sdk1~1.1_0\include" -I"C:\j2sdk1~1.1_0\include\win32"           
+
+COMPILE = $(CC) -c $(DEFS) $(INCLUDES) $(CPPFLAGS)
+ 
+.SUFFIXES:
+.SUFFIXES: .c .obj
+.c.obj:
+	$(COMPILE) $<
+
+ANSI2KNR = 
+o = .obj
+ 
+HEADERS = \
+    MGPPWrapperImpl.h   org_greenstone_mgpp_MGPPWrapper.h
+
+SOURCES = \
+    MGPPWrapperImpl.cpp
+
+OBJECTS = \
+    MGPPWrapperImpl$o   $(MGPPHOME)\text\libtextin.lib \
+    $(MGPPHOME)\lib\libmgpp.lib
+ 
+DISTFILES = Makefile.in $(HEADERS) $(SOURCES)
+ 
+all : compile link
+
+compile:
+        $(COMPILE) MGPPWrapperImpl.cpp
+
+link:
+        $(CC) -MD -LD $(OBJECTS) -Femgppjni.dll
+
+install: 
+
+clean:
+	del *$o 
Index: /trunk/mgpp/jni/win32.mak
===================================================================
--- /trunk/mgpp/jni/win32.mak	(revision 3930)
+++ /trunk/mgpp/jni/win32.mak	(revision 3930)
@@ -0,0 +1,70 @@
+###########################################################################
+#
+# win32 makefile -- mgpp\jni
+# A component of the Greenstone digital library software
+# from the New Zealand Digital Library Project at the
+# University of Waikato, New Zealand.
+#
+# Copyright (C) 1999  The New Zealand Digital Library Project
+#
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+###########################################################################
+ 
+MGPPHOME = ..
+
+AR = lib
+CC = cl
+CPPFLAGS = -GX
+
+DEFS = -DQUIET -DSHORT_SUFFIX -DHAVE_STRING_H -D__WIN32__
+INCLUDES = -I"$(MGPPHOME)" -I"$(MGPPHOME)\lib" -I"$(MGPPHOME)\text" \
+           -I"C:\j2sdk1~1.1_0\include" -I"C:\j2sdk1~1.1_0\include\win32"           
+
+COMPILE = $(CC) -c $(DEFS) $(INCLUDES) $(CPPFLAGS)
+ 
+.SUFFIXES:
+.SUFFIXES: .c .obj
+.c.obj:
+	$(COMPILE) $<
+
+ANSI2KNR = 
+o = .obj
+ 
+HEADERS = \
+    MGPPWrapperImpl.h   org_greenstone_mgpp_MGPPWrapper.h
+
+SOURCES = \
+    MGPPWrapperImpl.cpp
+
+OBJECTS = \
+    MGPPWrapperImpl$o   $(MGPPHOME)\text\libtextin.lib \
+    $(MGPPHOME)\lib\libmgpp.lib
+ 
+DISTFILES = Makefile.in $(HEADERS) $(SOURCES)
+ 
+all : compile link
+
+compile:
+        $(COMPILE) MGPPWrapperImpl.cpp
+
+link:
+        $(CC) -MD -LD $(OBJECTS) -Femgppjni.dll
+
+install: 
+
+clean:
+	del *$o 